<center><a href="ex20f.F">Actual source code: ex20f.F</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:20:56+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a>!
<a name="line2">  2: </a>      program main
<a name="line3">  3: </a>      implicit none
<a name="line4"> 4: </a> #include <A href="../../../../../include/finclude/petsc.h.html">include/finclude/petsc.h</A>
<a name="line5"> 5: </a> #include <A href="../../../../../include/finclude/petscsys.h.html">include/finclude/petscsys.h</A>
<a name="line6"> 6: </a> #include <A href="../../../../../include/finclude/petscvec.h.html">include/finclude/petscvec.h</A>
<a name="line7"> 7: </a> #include <A href="../../../../../include/finclude/petscviewer.h.html">include/finclude/petscviewer.h</A>

<a name="line9">  9: </a>!
<a name="line10"> 10: </a>!      This example demonstrates writing an array to a file in binary
<a name="line11"> 11: </a>!      format that may be read in by PETSc's <A href="../../../../../docs/manualpages/Vec/VecLoad.html#VecLoad">VecLoad</A>() routine.
<a name="line12"> 12: </a>!
<a name="line13"> 13: </a>       <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> n,i,ione
<a name="line14"> 14: </a>       <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr
<a name="line15"> 15: </a>       integer fd
<a name="line16"> 16: </a>       <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> veccookie(1)
<a name="line17"> 17: </a>       <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>      array(5)
<a name="line18"> 18: </a>       <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>              x
<a name="line19"> 19: </a>       <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>           v

<a name="line21"> 21: </a>       ione         = 1
<a name="line22"> 22: </a>       n            = 5
<a name="line23"> 23: </a>       veccookie(1) = 1211211 + 3

<a name="line25"> 25: </a>       call <A href="../../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(PETSC_NULL_CHARACTER,ierr)

<a name="line27"> 27: </a>       <font color="#4169E1">do</font> 10, i=1,5
<a name="line28"> 28: </a>         array(i) = i
<a name="line29"> 29: </a> 10    <font color="#4169E1">continue</font>

<a name="line31"> 31: </a>!      Open binary file <font color="#4169E1">for</font> writing
<a name="line32"> 32: </a>       call <A href="../../../../../docs/manualpages/Sys/PetscBinaryOpen.html#PetscBinaryOpen">PetscBinaryOpen</A>('testfile',FILE_MODE_WRITE,fd,ierr)
<a name="line33"> 33: </a>!      Write the <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> header
<a name="line34"> 34: </a>       call <A href="../../../../../docs/manualpages/Sys/PetscBinaryWrite.html#PetscBinaryWrite">PetscBinaryWrite</A>(fd,veccookie,ione,PETSC_INT,                    &amp;
<a name="line35"> 35: </a>     &amp;                       <A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>,ierr)
<a name="line36"> 36: </a>!      Write the array length
<a name="line37"> 37: </a>       call <A href="../../../../../docs/manualpages/Sys/PetscBinaryWrite.html#PetscBinaryWrite">PetscBinaryWrite</A>(fd,n,ione,PETSC_INT,<A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>,ierr)
<a name="line38"> 38: </a>!      Write the array
<a name="line39"> 39: </a>       call <A href="../../../../../docs/manualpages/Sys/PetscBinaryWrite.html#PetscBinaryWrite">PetscBinaryWrite</A>(fd,array,n,PETSC_DOUBLE,<A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>,ierr)
<a name="line40"> 40: </a>!      Close the file
<a name="line41"> 41: </a>       call <A href="../../../../../docs/manualpages/Sys/PetscBinaryClose.html#PetscBinaryClose">PetscBinaryClose</A>(fd,ierr)

<a name="line43"> 43: </a>!
<a name="line44"> 44: </a>!      Open the file <font color="#4169E1">for</font> reading by PETSc
<a name="line45"> 45: </a>!
<a name="line46"> 46: </a>       call <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,'testfile',                &amp;
<a name="line47"> 47: </a>     &amp;                       FILE_MODE_READ,v,ierr)
<a name="line48"> 48: </a>!
<a name="line49"> 49: </a>!      Load the vector
<a name="line50"> 50: </a>!
<a name="line51"> 51: </a>       Call <A href="../../../../../docs/manualpages/Vec/VecLoad.html#VecLoad">VecLoad</A>(v,PETSC_NULL_CHARACTER,x,ierr)
<a name="line52"> 52: </a>       call <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(v,ierr)
<a name="line53"> 53: </a>!
<a name="line54"> 54: </a>!      Print the vector
<a name="line55"> 55: </a>!
<a name="line56"> 56: </a>       call <A href="../../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(x,<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>,ierr)
<a name="line57"> 57: </a>!

<a name="line59"> 59: </a>       call <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(x,ierr)
<a name="line60"> 60: </a>       call <A href="../../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>(ierr)
<a name="line61"> 61: </a>       end

<a name="line63"> 63: </a>
</pre>
</body>

</html>
